VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ColorConverter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'### Photormin Open Source Project ### By Armin Niki ###########\
'# Thanx Branco Medeiros ( branco@apis.com.br ) For providing  #\
'#                                                 This Class  #\
'###############################################################\
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

#Const clMaxRed = MAXRGB
#Const clMaxGreen = MAXRGB
#Const clMaxBlue = MAXRGB
#Const clMaxHue = MAXHUE
#Const clMaxSaturation = MAXHSB
#Const clMaxBrightness = MAXHSB
Private Const MAXRGB = 255
Private Const MAXHUE = 359
Private Const MAXHSB = 100
Public Enum EColorConstants
clMaxRed = MAXRGB
clMaxGreen = MAXRGB
clMaxBlue = MAXRGB
clMaxHue = MAXHUE
clMaxSaturation = MAXHSB
clMaxBrightness = MAXHSB
End Enum
Public Function RGBAsString(ByVal RGBValue As Long) As String
' Returns the RGB value as string... :-P
Dim R As Long, G As Long, b As Long
Call SplitRGB(RGBValue, R, G, b)
RGBAsString = CStr(R) & ", " & CStr(G) & ", " & CStr(b)
End Function
Public Function HSBAsString(ByVal HSBValue As Long) As String
' Returns the HSB value as string... :-*
Dim H As Long, s As Long, l As Long
Call SplitHSB(HSBValue, H, s, l)
HSBAsString = CStr(H) & ", " & CStr(s) & ", " & CStr(l)
End Function
Public Function RGBToLong(ByVal Red As Long, _
ByVal Green As Long, _
ByVal Blue As Long)
'This function is just a wrap around the built in RGB function
Call xLimit(Red, 0, MAXRGB)
Call xLimit(Green, 0, MAXRGB)
Call xLimit(Blue, 0, MAXRGB)
RGBToLong = RGB(Red, Green, Blue)
End Function
Public Function HSBToLong(ByVal hue As Long, _
ByVal Saturation As Long, _
ByVal brightness As Long) As Long
' This function packs the HSB components into a Long, thus easing it's handling
Call xLimit(hue, 0, MAXHUE)
Call xLimit(Saturation, 0, MAXHSB)
Call xLimit(brightness, 0, MAXHSB)
HSBToLong = (hue * &H10000) Or (Saturation * 256) Or (brightness)
End Function
Function Red(ByVal RGBValue As Long) As Long
' Returns the Red component of an RGB value (In Windows, the Red, Green and Blue values are stored backwards)
Red = RGBValue And 255&
End Function
Function Green(ByVal RGBValue As Long) As Long
' Returns the Green component of an RGB value
Green = (RGBValue And &HFF00&) \ 256
End Function
Function Blue(ByVal RGBValue As Long) As Long
' Returns the Blue component of an RGB value
Blue = (RGBValue And &HFF0000) \ &H10000
End Function
Function hue(ByVal HSBValue As Long) As Long
' Returns the Hue component of an HSB value
hue = xLimit((HSBValue \ &H10000), 0, MAXHUE)
End Function
Function Saturation(ByVal HSBValue As Long) As Long
' Returns the Saturation component of an HSB value
Saturation = xLimit(((HSBValue And &HFF00&) \ 256), 0, MAXHSB)
End Function
Function brightness(ByVal HSBValue As Long) As Long
' Returns the Brightness component of an HSB value
brightness = xLimit((HSBValue And &HFF&), 0, MAXHSB)
End Function
Sub SplitRGB(ByVal RGBValue As Long, _
ByRef Red As Long, _
ByRef Green As Long, _
ByRef Blue As Long)
' Breaks an RGB value into its components
Red = (RGBValue And &HFF&)
Green = (RGBValue And &HFF00&) \ 256
Blue = (RGBValue And &HFF0000) \ &H10000
End Sub
Sub SplitHSB(ByVal HSBValue As Long, _
ByRef hue As Long, _
ByRef Saturation As Long, _
ByRef brightness As Long)
' Breaks an HSB value into its components
hue = xLimit((HSBValue \ &H10000), 0, MAXHUE)
Saturation = xLimit(((HSBValue And &HFF00&) \ 256), 0, MAXHSB)
brightness = xLimit((HSBValue And &HFF&), 0, MAXHSB)
End Sub
Function HSBToRGB(ByVal HSBValue As Long) As Long
' Converts an HSB value to the RGB color model Adapted from Java.awt.Color.java
Dim R As Long, G As Long, b As Long
Dim H As Long, s As Long, l As Long
Dim nH As Single, nS As Single, nL As Single
Dim nF As Single, nP As Single, nQ As Single, nT As Single
Dim lH As Long
Call SplitHSB(HSBValue, H, s, l)
If s > 0 Then
nH = H / 60: nL = l / 100: nS = s / 100
lH = Int(nH)
nF = nH - lH
nP = nL * (1 - nS)
nQ = nL * (1 - nS * nF)
nT = nL * (1 - nS * (1 - nF))
Select Case lH
Case 0
R = nL * 255
G = nT * 255
b = nP * 255
Case 1
R = nQ * 255
G = nL * 255
b = nP * 255
Case 2
R = nP * 255
G = nL * 255
b = nT * 255
Case 3
R = nP * 255
G = nQ * 255
b = nL * 255
Case 4
R = nT * 255
G = nP * 255
b = nL * 255
Case 5
R = nL * 255
G = nP * 255
b = nQ * 255
End Select
Else
R = (l * 255) / 100
G = R: b = R
End If
HSBToRGB = RGBToLong(R, G, b)
End Function
Function RGBToHSB(ByVal RGBValue As Long) As Long
' Converts an RGB value to the HSB color model Adapted from Java.awt.Color.java
Dim nTemp As Single
Dim lMin As Long, lMax As Long, lDelta As Long
Dim R As Long, G As Long, b As Long
Dim H As Long, s As Long, l As Long
Call SplitRGB(RGBValue, R, G, b)
lMax = IIf(R > G, IIf(R > b, R, b), IIf(G > b, G, b))
lMin = IIf(R < G, IIf(R < b, R, b), IIf(G < b, G, b))
lDelta = lMax - lMin
l = (lMax * 100) / 255
If lMax > 0 Then
s = (lDelta / lMax) * 100
If lDelta > 0 Then
If lMax = R Then
nTemp = (G - b) / lDelta
ElseIf lMax = G Then
nTemp = 2 + (b - R) / lDelta
Else
nTemp = 4 + (R - G) / lDelta
End If
H = nTemp * 60
If H < 0 Then H = H + 360
End If
End If
RGBToHSB = HSBToLong(H, s, l)
End Function
Private Function xLimit(Value As Long, _
Lower As Long, Higher As Long) As Long
' Auxiliary procedure to limit (!) a given value to a specified range
If Value < Lower Then Value = Lower
If Value > Higher Then Value = Higher
xLimit = Value
End Function
